#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::Text;
using namespace System::Net::Sockets;
using namespace System::Windows::Forms;
using namespace System::Threading;
using namespace System::IO;

public ref class cTelnetClient
{

public:

	cTelnetClient(void);

	static System::Object^ m_objLock = gcnew(System::Object);
	
public:

	static int AUTH_LOGIN = 100;
	static int AUTH_PASSWORD = 101;
    static int AUTH_WAIT = 102;
    static int AUTH_DONE = 103;

    static int AUTH_STATUS_SUCCESS = 103;
	static int AUTH_STATUS_FAIL = 104;
	static int AUTH_STATUS_WAIT = 105;

	static Socket^ m_objSocket;

	String^ m_sLoginTelnet;
    String^ m_sPasswordTelnet;
    static String^ m_sRecvBuffer;

    int m_nAuthStep;
    static int m_nAuthStatus;

    static int RECV_BUFFER_SIZE = 512;
	static array<System::Byte>^ m_sAsyncBuffer;

private:

	static void OnReceive(IAsyncResult^ ar);
	void ReceiveData();
	void OnRequest(String^ sCommand, ArrayList^ objParamList);

	String^ FindRequest();
	void OnAuthrization(String^ sData);

	bool ParseRequest(String^ sRequest, String^% sCommand, ArrayList^% objParamList);

	void OnDisconnect();

public:

	void SendCommand(String^ sCommand);
	void SendCommand(String^ sCommand, ArrayList^ objParamList);
	
	bool Connect(String^ sToIP, int nToPort, String^ sLogin, String^ sPassword);
	void CloseSocket();
	
};
