#include "StdAfx.h"
#include "CallList.h"

using namespace System;
using namespace System::Collections;
using namespace System::Text;

cCallData::cCallData()
{
    m_nCallId       = -1;
    m_nSessionId    = -1;

	m_unUserId       = 0;
	m_nCallType     = 0;
	m_unQueueId      = 0;
	m_nDigitPRESS   = 0;
	m_unStealthId    = 0;

	m_objBindCallData = nullptr;
	m_bDigitDetect = false;

	m_bConnected = false;
	m_bStealthListening = false;
	
	m_nPlayWaveType = PLAY_WAVE_NONE_TYPE;

	m_sCallerId = gcnew String("");
	m_sUserId = gcnew String("");
	m_sDigitPRESS = gcnew String("");
	m_sStealthDialNo = gcnew String("");

	m_sCodec = gcnew String("");
}

cCallList::cCallList(void)
{
	m_objCallList = gcnew Hashtable(256);
}

cCallData^ cCallList::AddCall(int nCallId)
{
    cCallData^ objCallData = gcnew cCallData();
    objCallData->m_nCallId = nCallId;
	
    m_objCallList->Add(nCallId, objCallData);

    return objCallData;
}

void cCallList::RemoveCall(cCallData^ objCallData)
{
    m_objCallList->Remove(objCallData->m_nCallId);
    objCallData = nullptr;
}

cCallData^ cCallList::FindCall(int nCallId)
{
     return (cCallData^) m_objCallList[nCallId];
}

void cCallList::DeleteAll()
{
    ArrayList^ objCloseCallList = gcnew ArrayList();

    IDictionaryEnumerator^ enumerator = m_objCallList->GetEnumerator();

    while(enumerator->MoveNext())
    {
        objCloseCallList->Add(enumerator->Value);
    }

    for (int nCount = 0; nCount < objCloseCallList->Count; nCount++)
    {
        cCallData^ objCallData = (cCallData^) objCloseCallList[nCount];
		cServerSIP::m_objServerSIP->CloseCall(objCallData);
    }
}

int cCallList::GetCount()
{
    return m_objCallList->Count;
}