// TelnetLoginDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "TelnetLoginDlg.h"
#include "TelnetClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTelnetLoginDlg dialog


CTelnetLoginDlg::CTelnetLoginDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTelnetLoginDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTelnetLoginDlg)
	m_nServerPort = 4332;
	m_objPassword = _T("admin");
	m_objServerIP = _T("");
	m_objLogin = _T("admin");
	//}}AFX_DATA_INIT
}


void CTelnetLoginDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTelnetLoginDlg)
	DDX_Text(pDX, IDC_EDIT_SERVER_PORT, m_nServerPort);
	DDX_Text(pDX, IDC_EDIT_SERVER_PASSWORD, m_objPassword);
	DDX_Text(pDX, IDC_EDIT_SERVER_IP, m_objServerIP);
	DDX_Text(pDX, IDC_EDIT_SERVER_LOGIN, m_objLogin);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTelnetLoginDlg, CDialog)
	//{{AFX_MSG_MAP(CTelnetLoginDlg)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTelnetLoginDlg message handlers

void CTelnetLoginDlg::OnButtonConnect() 
{
	UpdateData();

	if(m_pTelnetClient->Connect(m_objServerIP, m_nServerPort, m_objLogin, m_objPassword))
		EndDialog(IDOK);
}

